/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * 
 * TOKEN Bancar cu ceas extern
 *
 * Sirbu Alexandru
 * 332CB
 *********************************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>

#define F_CPU 16000000
#include <util/delay.h>

#include <string.h>
#include <stdlib.h>
#include "lcd.h"

char clock(char reg)
{
		TWSR = 0x00;
	TWBR = 0x0C;
	int rep=0;
	while (rep==0)
	{
		rep = 1;
		TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
		while (!(TWCR & (1<<TWINT))); 
		TWDR = 0b10100010;
		TWCR = (1<<TWINT) | (1<<TWEN);
		while (!(TWCR & (1<<TWINT))); 
		if ((TWSR & 0xF8) != 0x18)
		{
			rep = 0;
			continue;
		}
		TWDR = reg;
		TWCR = (1<<TWINT) | (1<<TWEN);
		while (!(TWCR & (1<<TWINT))); 
		if ((TWSR & 0xF8) != 0x28)
		{
			rep = 0;
			continue;
		}
	}
	
	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	while (!(TWCR & (1<<TWINT))); 

	TWDR = 0b10100011;
	TWCR = (1<<TWINT) | (1<<TWEN); 
	while (!(TWCR & (1<<TWINT)));
	TWCR = (1<<TWINT) | (1<<TWEN);
	
	while (!(TWCR & (1<<TWINT))); 
	int val = TWDR;
	TWCR = (1<<TWINT)|(1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	char nr;
	
	nr = (val & 0b00001111);
	if (reg == 4)
		nr = nr + ((val & 0b00110000) >> 4) * 10;
	else
		nr = nr + ((val & 0b01110000) >> 4) * 10;
	return nr;
}


int main()
{
	LCD_init();
	LCD_printn("PIN ", strlen("PIN "));
	
	int cod[6];
	int poz = 0;
	int cod_intrare[6]={1,2,3,4,5,6};
	int block = 0;
	DDRD |= ( 1 << PD7 );
	PORTD |= ( 1<< PD7 );
	DDRA &= (1 << PA7 | 1 << PA6 | 1<< PA5 | 1 << PA4 | 1 << PA3 | 1<<PA1 | 1 <<PA2);
	PORTA |= (1 << PA7 | 1 << PA6 | 1 << PA5 |1 << PA4 | 1 << PA3 | 1<<PA1 | 1 <<PA2);
    	while(1){
			_delay_ms(250);
			if (poz == 6)
			{
				LCD_writeInstruction(0b10000000);
				LCD_printn("               ",strlen("               "));
				LCD_writeInstruction(0b10000000);
				int i,j=1;
				for (i=0;i<6;i++)
					if (cod[i] != cod_intrare[i])
					{
						j=0;
						break;
					}
				if (j==1)
				{
					LCD_printn("CORECT ",7);
					int seed = 0;
					//char* aux = calloc(5, sizeof(char));
					char secret[8];
					seed += clock(2) / 30;
					seed += clock(3) * 60;
					seed += clock(4) * 60 * 60;
					//itoa(seed,aux,10);
					srand(seed);
					secret[0]='0'+rand()%10;
					secret[1]='0'+rand()%10;
					secret[2]='0'+rand()%10;
					secret[3]='0'+rand()%10;
					secret[4]='0'+rand()%10;
					secret[5]='0'+rand()%10;
					secret[6]='0'+rand()%10;
					secret[7]='0'+rand()%10;
					LCD_printn(secret,8);
				}
				else
					LCD_printn("INCORECT",8);
				poz=0;
				block=1;
				
			}
			if (block == 0)
			{
				if ((PINA & (1<<PA1)) == 0) {
					PORTD ^= (1 << PD7);
					LCD_printn("1",1);
					cod[poz]=1;
					poz++;
				}
				else
				if ((PINA & (1<<PA2)) == 0) {
					PORTD ^= (1 << PD7);
					LCD_printn("2",1);
					cod[poz]=2;
					poz++;
				}
				else
				if ((PINA & (1<<PA3)) == 0) {
					PORTD ^= (1 << PD7);
					LCD_printn("3",1);
					cod[poz]=3;
					poz++;
				}
				else
				if ((PINA & (1<<PA4)) == 0) {
					PORTD ^= (1 << PD7);
					LCD_printn("4",1);
					cod[poz]=4;
					poz++;
				}
				else
				if ((PINA & (1<<PA5)) == 0) {
					PORTD ^= (1 << PD7);
					LCD_printn("5",1);
					cod[poz]=5;
					poz++;
				}
				else
				if ((PINA & (1<<PA6)) == 0) {
					PORTD ^= (1 << PD7);
					LCD_printn("6",1);
					cod[poz]=6;
					poz++;
				}
				else
				if ((PINA & (1<<PA7)) == 0) {
					PORTD ^= (1 << PD7);
					if (poz != 0)
					{
						poz--;
						LCD_writeInstruction(0b10000000 + strlen("PIN ") + poz);
						LCD_printn(" ",1);
						LCD_writeInstruction(0b10000000 + strlen("PIN ") + poz);
					}
				}
			}
			else
			{
				if ((PINA & (1<<PA7)) == 0) {
					PORTD ^= (1 << PD7);
					LCD_writeInstruction(0b10000000);
					LCD_printn("               ",strlen("               "));
					LCD_writeInstruction(0b10000000);
					LCD_printn("PIN ", strlen("PIN "));
					block=0;
				}
			}
		}
		
	
	return 0;
}
